{
Vollstaendig: JA
Syntaktisch : JA
Ausgetestet : NEIN
Bemerkungen :

R. Lohner  27.06.90  Fuer alle zusaetzlichen Standardfunktionen ( 5.10 ) sind
                     zwar die Schnittstellen vorhanden, aber keine Implemen-
                     tierungen !!!

R. Lohner  09.12.91  Modul c_ariaux geaendert, deshalb auch Anpassungen hier.
}

MODULE c_ari;                   {  Komplexe Arithmetik,  Stand : 09.12.91 }

$off

{ nur ATARI System : }

USE L_ARI;

$on


USE c_ariaux;    { Hilfsroutinen fuer komplexe Division }

$off
 
PROCEDURE _MATH_ERROR ( errornr : INTEGER );    EXTERNAL;

$on

{******************************************************************}
{                                                                  }
{      PASCAL-SC ARITHMETIC ERRORHANDLER VERSION 1.0               }
{                                                                  }
{******************************************************************}

procedure traceback (var t:text) ; external f_back ;
const   stderr = 2 ; { standard error }
procedure rewrite (var t : text ; nr : integer) ; external f_rwrn ;
procedure exit    (retcode : integer)           ; external a_exit ;

global  { _c_math_error must be global, if c_ari is a library }
procedure _c_math_error (errnr : integer) ;
  var message : text;
  begin
    rewrite(message,stderr);
    case  errnr  of
       81: writeln (message, 'Real division by zero') ;
       92: writeln (message, 'Illegal notation of complex number in read complex') ;
      250: writeln (message, 'Function not yet implemented') ;
     else: writeln (message, 'Unknown error') ;
    end ;
    traceback (message)  ;
    exit (-1) ;
  end { _c_math_error } ;




{---------------------------------------------------------------------------}
{ 1. Transferfunktionen                                                     }
{---------------------------------------------------------------------------}
{    1.0 Zuweisungen                                                        }
{---------------------------------------------------------------------------}



GLOBAL OPERATOR := ( VAR A : COMPLEX; B : REAL );

BEGIN
  A.RE := B;
  A.IM := 0.0
END;



{---------------------------------------------------------------------------}
{    1.1 eigentliche Transferfunktionen                                     }
{---------------------------------------------------------------------------}




GLOBAL FUNCTION COMPL ( A : REAL ) : COMPLEX;

BEGIN
  COMPL.RE:= A;
  COMPL.IM:= 0.0
END;




GLOBAL FUNCTION COMPL ( A, B : REAL ) : COMPLEX;

BEGIN
  COMPL.RE:= A;
  COMPL.IM:= B
END;




GLOBAL FUNCTION RE ( VAR A : COMPLEX ) : REAL;

BEGIN
  RE:= A.RE
END;




GLOBAL FUNCTION IM ( VAR A : COMPLEX ) : REAL;

BEGIN
  IM:= A.IM
END;




{---------------------------------------------------------------------------}
{ 2. Spezielle Funktionen                                                   }
{---------------------------------------------------------------------------}
{    2.1 Konjugation                                                        }
{---------------------------------------------------------------------------}

 
GLOBAL FUNCTION CONJ ( VAR A : COMPLEX ) : COMPLEX;
 
BEGIN
  CONJ.RE:=  A.RE;
  CONJ.IM:= -A.IM
END;




{---------------------------------------------------------------------------}
{ 3. Vergleiche                                                             }
{---------------------------------------------------------------------------}
{    3.1 Vergleiche REAL, COMPLEX mit REAL, COMPLEX                         }
{---------------------------------------------------------------------------}
{SEKTOR V11                                                                 }
{---------------------------------------------------------------------------}
{        3.1.1 Vergleiche REAL mit REAL                                     }
{---------------------------------------------------------------------------}




{         ... sind bereits in die Run-time-Library integriert.              }


 

{---------------------------------------------------------------------------}
{        3.1.2 Vergleiche REAL mit COMPLEX                                  }
{---------------------------------------------------------------------------}
 



GLOBAL OPERATOR = ( A : REAL; VAR B : COMPLEX ) EQRCR : BOOLEAN;

BEGIN
  EQRCR:= ( A = B.RE ) AND ( B.IM = 0.0 )
END;




GLOBAL OPERATOR <> ( A : REAL; VAR B : COMPLEX ) NERCR : BOOLEAN;

BEGIN
  NERCR:= ( A <> B.RE ) OR ( B.IM <> 0.0 )
END;




GLOBAL OPERATOR <= ( A : REAL; VAR B : COMPLEX ) LERCR : BOOLEAN;

BEGIN
  LERCR:= ( A <= B.RE ) AND ( 0.0 <= B.IM )
END;




GLOBAL OPERATOR < ( A : REAL; VAR B : COMPLEX ) LTRCR : BOOLEAN;

BEGIN
  LTRCR:=   ( A <= B.RE ) AND ( 0.0 <= B.IM ) AND
          ( ( A <> B.RE ) OR  ( 0.0 <> B.IM ) )
END;




GLOBAL OPERATOR >= ( A : REAL; VAR B : COMPLEX ) GERCR : BOOLEAN;

BEGIN
  GERCR:= ( A >= B.RE ) AND ( 0.0 >= B.IM )
END;




GLOBAL OPERATOR > ( A : REAL; VAR B : COMPLEX ) GTRCR : BOOLEAN;

BEGIN
  GTRCR:=   ( A >= B.RE ) AND ( 0.0 >= B.IM ) AND
          ( ( A <> B.RE ) OR  ( 0.0 <> B.IM ) ) 
END;




{---------------------------------------------------------------------------}
{        3.1.3 Vergleiche COMPLEX mit REAL                                  }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR = ( VAR A : COMPLEX; B : REAL ) EQCRR : BOOLEAN;

BEGIN
  EQCRR:= ( A.RE = B ) AND ( A.IM = 0.0 )
END;




GLOBAL OPERATOR <> ( VAR A : COMPLEX; B : REAL ) NECRR : BOOLEAN;

BEGIN
  NECRR:= ( A.RE <> B ) OR ( A.IM <> 0.0 )
END;




GLOBAL OPERATOR <= ( VAR A : COMPLEX; B : REAL ) LECRR : BOOLEAN;

BEGIN
  LECRR:= ( A.RE <= B ) AND ( A.IM <= 0.0 )
END;




GLOBAL OPERATOR < ( VAR A : COMPLEX; B : REAL ) LTCRR : BOOLEAN;

BEGIN
  LTCRR:=   ( A.RE <= B ) AND ( A.IM <= 0.0 ) AND
          ( ( A.RE <> B ) OR  ( A.IM <> 0.0 ) )
END;




GLOBAL OPERATOR >= ( VAR A : COMPLEX; B : REAL ) GECRR : BOOLEAN;

BEGIN
  GECRR:= ( A.RE >= B ) AND ( A.IM >= 0.0 )
END;




GLOBAL OPERATOR > ( VAR A : COMPLEX; B : REAL ) GTCRR : BOOLEAN;

BEGIN
  GTCRR:=   ( A.RE >= B ) AND ( A.IM >= 0.0 ) AND
          ( ( A.RE <> B ) OR  ( A.IM <> 0.0 ) ) 
END;




{---------------------------------------------------------------------------}
{        3.1.4 Vergleiche COMPLEX mit COMPLEX                               }
{---------------------------------------------------------------------------}





GLOBAL OPERATOR =  ( VAR A, B : COMPLEX ) EQCRCR : BOOLEAN;

BEGIN
  EQCRCR:= ( A.RE = B.RE ) AND ( A.IM = B.IM )
END;




GLOBAL OPERATOR <> ( VAR A, B : COMPLEX ) NECRCR : BOOLEAN;

BEGIN
  NECRCR:= ( A.RE <> B.RE ) OR ( A.IM <> B.IM )
END;




GLOBAL OPERATOR <= ( VAR A, B : COMPLEX ) LECRCR : BOOLEAN;

BEGIN
  LECRCR:= ( A.RE <= B.RE ) AND ( A.IM <= B.IM )
END;




GLOBAL OPERATOR < ( VAR A, B : COMPLEX ) LTCRCR : BOOLEAN;

BEGIN
  LTCRCR:=   ( A.RE <= B.RE ) AND ( A.IM <= B.IM ) AND
           ( ( A.RE <> B.RE ) OR  ( A.IM <> B.IM ) )
END;




GLOBAL OPERATOR >= ( VAR A, B : COMPLEX ) GECRCR : BOOLEAN;

BEGIN
  GECRCR:= ( A.RE >= B.RE ) AND ( A.IM >= B.IM )
END;




GLOBAL OPERATOR > ( VAR A, B : COMPLEX ) GTCRCR : BOOLEAN;

BEGIN
  GTCRCR:=   ( A.RE >= B.RE ) AND ( A.IM >= B.IM ) AND
           ( ( A.RE <> B.RE ) OR  ( A.IM <> B.IM ) ) 
END;




{---------------------------------------------------------------------------}
{ 4. Arithmetische Operatoren ( + - * / ) und Verbandsoperatoren            }
{---------------------------------------------------------------------------}
{    4.1 Monadische Operatoren                                              }
{---------------------------------------------------------------------------}
{SEKTOR A01                                                                 }
{---------------------------------------------------------------------------}



 
GLOBAL OPERATOR + ( VAR A : COMPLEX ) PLUSCR : COMPLEX;

BEGIN
  PLUSCR:= A
END;




GLOBAL OPERATOR - ( VAR A : COMPLEX ) MINUSCR : COMPLEX;

BEGIN
  MINUSCR.RE:= -A.RE;
  MINUSCR.IM:= -A.IM
END;




{---------------------------------------------------------------------------}
{    4.2 Operatoren mit Argumenten REAL, COMPLEX mit REAL, COMPLEX          }
{---------------------------------------------------------------------------}
{SEKTOR A11                                                                 }
{---------------------------------------------------------------------------}


{ Die folgende Funktion _c_division_ gehoert laut Numerierung nach          }
{   4.2.4 Operatoren fuer COMPLEX mit COMPLEX                               }
{ Fuer alle Divisionen, die im Nenner den Typ COMPLEX aufweisen, wird       }
{ der Zaehler falls noetig auf den Typ COMPLEX angehoben und die Division   }
{ COMPLEX / COMPLEX gemaess der Funktion _c_division_ ausgefuehrt.          } 

{ Die Hilfsprozedur produkt und die Funktion quotient sind im Modul         }
{ C_ARIAUX definiert.                                                       }



FUNCTION _c_division_ ( VAR a, b : COMPLEX; round : INTEGER ) : COMPLEX;

VAR zoverfl,noverfl : INTEGER;
    z1,n1           : REAL;
    z2,n2           : INTERVAL;

BEGIN
  produkt( b.re, b.re, b.im, b.im, noverfl, n1,n2 );

  produkt( a.re, b.re, a.im, b.im, zoverfl, z1,z2 );
  _c_division_.RE:= quotient( z1,z2, n1,n2, round, zoverfl, noverfl );

  produkt( a.im, b.re,-a.re, b.im, zoverfl, z1,z2 );
  _c_division_.IM:= quotient( z1,z2, n1,n2, round, zoverfl, noverfl );

END;   { _c_division_ }




{---------------------------------------------------------------------------}
{        4.2.1 Operatoren mit Argumenten REAL mit REAL                      }
{---------------------------------------------------------------------------}




{         ... sind bereits in die Run-time-Library integriert.              }




{---------------------------------------------------------------------------}
{        4.2.2 Operatoren mit Argumenten REAL mit COMPLEX                   }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( A : REAL; VAR B : COMPLEX ) ADDRCR : COMPLEX;

BEGIN
  ADDRCR.RE:= A + B.RE;
  ADDRCR.IM:= B.IM
END;




GLOBAL OPERATOR - ( A : REAL; VAR B : COMPLEX ) SUBRCR : COMPLEX;

BEGIN
  SUBRCR.RE:= A - B.RE;
  SUBRCR.IM:= -B.IM
END;




GLOBAL OPERATOR * ( A : REAL; VAR B : COMPLEX ) MULRCR : COMPLEX;

BEGIN
  MULRCR.RE:= A * B.RE;
  MULRCR.IM:= A * B.IM
END;




GLOBAL OPERATOR / ( A : REAL; VAR B : COMPLEX ) DIVRCR : COMPLEX;

BEGIN
  DIVRCR:= _c_division_( COMPL(A), B, 0 )
END;




GLOBAL OPERATOR +< ( A : REAL; VAR B : COMPLEX ) ADDDOWNRCR : COMPLEX;

BEGIN
  ADDDOWNRCR.RE:= A +< B.RE;
  ADDDOWNRCR.IM:= B.IM
END;




GLOBAL OPERATOR -< ( A : REAL; VAR B : COMPLEX ) SUBDOWNRCR : COMPLEX;

BEGIN
  SUBDOWNRCR.RE:= A -< B.RE;
  SUBDOWNRCR.IM:= -B.IM
END;




GLOBAL OPERATOR *< ( A : REAL; VAR B : COMPLEX ) MULDOWNRCR : COMPLEX;

BEGIN
  MULDOWNRCR.RE:= A *< B.RE;
  MULDOWNRCR.IM:= A *< B.IM
END;




GLOBAL OPERATOR /< ( A : REAL; VAR B : COMPLEX ) DIVDOWNRCR : COMPLEX;

BEGIN
  DIVDOWNRCR:= _c_division_( COMPL(A), B, -1 )
END;




GLOBAL OPERATOR +> ( A : REAL; VAR B : COMPLEX ) ADDUPRCR : COMPLEX;

BEGIN
  ADDUPRCR.RE:= A +> B.RE;
  ADDUPRCR.IM:= B.IM
END;




GLOBAL OPERATOR -> ( A : REAL; VAR B : COMPLEX ) SUBUPRCR : COMPLEX;

BEGIN
  SUBUPRCR.RE:= A -> B.RE;
  SUBUPRCR.IM:= -B.IM
END;




GLOBAL OPERATOR *> ( A : REAL; VAR B : COMPLEX ) MULUPRCR : COMPLEX;

BEGIN
  MULUPRCR.RE:= A *> B.RE;
  MULUPRCR.IM:= A *> B.IM
END;




GLOBAL OPERATOR /> ( A : REAL; VAR B : COMPLEX ) DIVUPRCR : COMPLEX;

BEGIN
  DIVUPRCR:= _c_division_( COMPL(A), B, +1 )
END;




{---------------------------------------------------------------------------}
{        4.2.3 Operatoren mit Argumenten COMPLEX mit REAL                   }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : COMPLEX; B : REAL ) ADDCRR : COMPLEX;

BEGIN
  ADDCRR.RE:= A.RE + B;
  ADDCRR.IM:= A.IM
END;




GLOBAL OPERATOR - ( VAR A : COMPLEX; B : REAL ) SUBCRR : COMPLEX;

BEGIN
  SUBCRR.RE:= A.RE - B;
  SUBCRR.IM:= A.IM
END;




GLOBAL OPERATOR * ( VAR A : COMPLEX; B : REAL ) MULCRR : COMPLEX;

BEGIN
  MULCRR.RE:= A.RE * B;
  MULCRR.IM:= A.IM * B
END;




GLOBAL OPERATOR / ( VAR A : COMPLEX; B : REAL ) DIVCRR : COMPLEX;

BEGIN
  DIVCRR.RE:= A.RE / B;
  DIVCRR.IM:= A.IM / B
END;




GLOBAL OPERATOR +< ( VAR A : COMPLEX; B : REAL ) ADDDOWNCRR : COMPLEX;

BEGIN
  ADDDOWNCRR.RE:= A.RE +< B;
  ADDDOWNCRR.IM:= A.IM
END;




GLOBAL OPERATOR -< ( VAR A : COMPLEX; B : REAL ) SUBDOWNCRR : COMPLEX;

BEGIN
  SUBDOWNCRR.RE:= A.RE -< B;
  SUBDOWNCRR.IM:= A.IM
END;




GLOBAL OPERATOR *< ( VAR A : COMPLEX; B : REAL ) MULDOWNCRR : COMPLEX;

BEGIN
  MULDOWNCRR.RE:= A.RE *< B;
  MULDOWNCRR.IM:= A.IM *< B
END;




GLOBAL OPERATOR /< ( VAR A : COMPLEX; B : REAL ) DIVDOWNCRR : COMPLEX;

BEGIN
  DIVDOWNCRR.RE:= A.RE /< B;
  DIVDOWNCRR.IM:= A.IM /< B
END;




GLOBAL OPERATOR +> ( VAR A : COMPLEX; B : REAL ) ADDUPCRR : COMPLEX;

BEGIN
  ADDUPCRR.RE:= A.RE +> B;
  ADDUPCRR.IM:= A.IM
END;




GLOBAL OPERATOR -> ( VAR A : COMPLEX; B : REAL ) SUBUPCRR : COMPLEX;

BEGIN
  SUBUPCRR.RE:= A.RE -> B;
  SUBUPCRR.IM:= A.IM
END;




GLOBAL OPERATOR *> ( VAR A : COMPLEX; B : REAL ) MULUPCRR : COMPLEX;

BEGIN
  MULUPCRR.RE:= A.RE *> B;
  MULUPCRR.IM:= A.IM *> B
END;




GLOBAL OPERATOR /> ( VAR A : COMPLEX; B : REAL ) DIVUPCRR : COMPLEX;

BEGIN
  DIVUPCRR.RE:= A.RE /> B;
  DIVUPCRR.IM:= A.IM /> B
END;




{---------------------------------------------------------------------------}
{        4.2.4 Operatoren mit Argumenten COMPLEX mit COMPLEX                }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A, B : COMPLEX ) ADDCRCR : COMPLEX;

BEGIN
  ADDCRCR.RE:= A.RE + B.RE;
  ADDCRCR.IM:= A.IM + B.IM
END;




GLOBAL OPERATOR - ( VAR A, B : COMPLEX ) SUBCRCR : COMPLEX;

BEGIN
  SUBCRCR.RE:= A.RE - B.RE;
  SUBCRCR.IM:= A.IM - B.IM
END;




GLOBAL OPERATOR * ( VAR A, B : COMPLEX ) MULCRCR : COMPLEX;

BEGIN
  MULCRCR.RE:= #*( A.RE * B.RE - A.IM * B.IM );
  MULCRCR.IM:= #*( A.RE * B.IM + A.IM * B.RE )
END;




GLOBAL OPERATOR / ( VAR A, B : COMPLEX ) DIVCRCR : COMPLEX;

BEGIN
  DIVCRCR:= _c_division_( A, B, 0 )
END;




GLOBAL OPERATOR +< ( VAR A, B : COMPLEX ) ADDDOWNCRCR : COMPLEX;

BEGIN
  ADDDOWNCRCR.RE:= A.RE +< B.RE;
  ADDDOWNCRCR.IM:= A.IM +< B.IM
END;




GLOBAL OPERATOR -< ( VAR A, B : COMPLEX ) SUBDOWNCRCR : COMPLEX;

BEGIN
  SUBDOWNCRCR.RE:= A.RE -< B.RE;
  SUBDOWNCRCR.IM:= A.IM -< B.IM
END;




GLOBAL OPERATOR *< ( VAR A, B : COMPLEX ) MULDOWNCRCR : COMPLEX;

BEGIN
  MULDOWNCRCR.RE:= #<( A.RE * B.RE - A.IM * B.IM );
  MULDOWNCRCR.IM:= #<( A.RE * B.IM + A.IM * B.RE )
END;




GLOBAL OPERATOR /< ( VAR A, B : COMPLEX ) DIVDOWNCRCR : COMPLEX;

BEGIN
  DIVDOWNCRCR:= _c_division_( A, B, -1 )
END;




GLOBAL OPERATOR +> ( VAR A, B : COMPLEX ) ADDUPCRCR : COMPLEX;

BEGIN
  ADDUPCRCR.RE:= A.RE +> B.RE;
  ADDUPCRCR.IM:= A.IM +> B.IM
END;




GLOBAL OPERATOR -> ( VAR A, B : COMPLEX ) SUBUPCRCR : COMPLEX;

BEGIN
  SUBUPCRCR.RE:= A.RE -> B.RE;
  SUBUPCRCR.IM:= A.IM -> B.IM
END;




GLOBAL OPERATOR *> ( VAR A, B : COMPLEX ) MULUPCRCR : COMPLEX;

BEGIN
  MULUPCRCR.RE:= #>( A.RE * B.RE - A.IM * B.IM );
  MULUPCRCR.IM:= #>( A.RE * B.IM + A.IM * B.RE )
END;




GLOBAL OPERATOR /> ( VAR A, B : COMPLEX ) DIVUPCRCR : COMPLEX;

BEGIN
  DIVUPCRCR:= _c_division_( A, B, +1 )
END;



$off

{---------------------------------------------------------------------------}
{ 5. Komplexe Standardfunktionen                                            }
{    Quelltext fuer komplexe Standardfunktionsbibliothek fuer PASCAL-SC 2   }
{    Version vom 11.Februar 1988 auf kws SAM 68k                            }
{---------------------------------------------------------------------------}




FUNCTION LN_APP( L : LONGREAL ) : LONGREAL;

  EXTERNAL;




FUNCTION l_dotround( VAR akku : DOTPRECISION ) : LONGREAL;

VAR x, y : REAL;

BEGIN
  CASE SIGN( akku ) OF
     0 : l_dotround:= LONG( 0.0 );
     1 : BEGIN
           x:= #<( akku );   
           y:= #<( akku - x );
           l_dotround:= LONG( x ) + LONG( y )
         END;
    -1 : BEGIN
           x:= #>( akku ); 
           y:= #>( akku - x );
           l_dotround:= LONG( x ) + LONG( y )
         END
  END
END;




{---------------------------------------------------------------------------}
{    5.1 Argumentfunktion                                                   }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARG( VAR z : COMPLEX ) : REAL;

CONST pi = 3.141592653590;

VAR ca : REAL;

BEGIN
  ca:= ARCTAN2( z.IM, z.RE );
  IF z.RE < 0.0 THEN  IF z.IM < 0.0 THEN ARG:= ca - pi  { Ausloeschung ??? }
                                    ELSE ARG:= ca + pi  { R.Lohner, 2.4.90 }
                ELSE  ARG:= ca
END ;


$on

{---------------------------------------------------------------------------}
{    5.2 Betrag                                                             }
{---------------------------------------------------------------------------}
 
 
GLOBAL FUNCTION ABS( z : COMPLEX ) : REAL;

$off
CONST grenzexpo = 50;
$on
CONST grenzexpo = 500;

VAR hilf  : REAL;
    scale : INTEGER;

BEGIN
  {***   ABS:= SQRT( SQR( z.RE ) + SQR( z.IM ) )   ***}

  IF ( expo(z.RE) >= grenzexpo ) OR ( expo(z.IM) >= grenzexpo )
  THEN
  BEGIN
    { Ueberlauf vermeiden }
    z.RE:= comp( mant(z.RE), expo(z.RE)-grenzexpo );   {  Unterlauf durch diese }
    z.IM:= comp( mant(z.IM), expo(z.IM)-grenzexpo );   {  Skalierung moeglich ! }
    scale:= grenzexpo;
  END
  ELSE
  IF ( expo(z.RE) <= -grenzexpo+1 ) AND ( expo(z.IM) <= -grenzexpo+1 )
  THEN
  BEGIN
    { Unterlauf vermeiden }
    z.RE:= comp( mant(z.RE), expo(z.RE)+grenzexpo );
    z.IM:= comp( mant(z.IM), expo(z.IM)+grenzexpo );
    scale:= -grenzexpo;
  END
  ELSE
    { Kein Grund zur Panik }
    scale:= 0;

  hilf:= sqrt( #*( z.RE * z.RE + z.IM * z.IM ) );  { Genauigkeit ????? }
  ABS:= comp( mant(hilf), expo(hilf)+scale );

END;




{---------------------------------------------------------------------------}
{    5.3 Quadrat                                                            }
{---------------------------------------------------------------------------}
 
 
GLOBAL FUNCTION SQR( VAR z : COMPLEX ) : COMPLEX;

BEGIN
  SQR:= z * z
END;

$off


{---------------------------------------------------------------------------}
{    5.4 Quadratwurzel                                                      }
{---------------------------------------------------------------------------}

 
GLOBAL FUNCTION SQRT( z : COMPLEX ) : COMPLEX;

VAR betrag, x, ein_halb : LONGREAL;
    zwischen            : REAL;
    wurzel              : LONGREAL;

BEGIN
  ein_halb:= LONG( 0.5 );
  IF z.RE = 0.0 THEN
    IF z.IM = 0.0 THEN SQRT:= COMPL( 0.0, 0.0 )
    ELSE
    BEGIN
      zwischen:= SHORT( SQRT( ein_halb * LONG( ABS( z.IM ) ) ) );

      { SQRT:= SQRT( 0.5 * ABS( z.IM ) ) +- i * SQRT( 0.5 * ABS( z.IM ) ) }

      SQRT.RE:= zwischen;
      IF z.IM > 0.0 THEN SQRT.IM:= zwischen ELSE SQRT.IM:= -zwischen
    END
  ELSE    { z.RE <> 0.0 }
  BEGIN
    betrag:= LONG( ABS( z ) );
    x:= LONG( z.RE );
    IF z.RE > 0.0 THEN
    BEGIN
      IF z.RE < 1.0 THEN wurzel:= SQRT( ein_halb * ( x + betrag ) )
      ELSE
        wurzel:= SQRT( ein_halb * x + ein_halb * betrag );

      { SQRT:= SQRT( 0.5 * z.RE + 0.5 * ABS( z ) ) 
                 + i * 0.5 * z.IM * 1 / SQRT( 0.5 * z.RE + 0.5 * ABS( z ) }

      SQRT:= COMPL( SHORT( wurzel )
                     , SHORT( ( ein_halb * LONG( z.IM ) ) / wurzel ) )
    END
    ELSE     { z.RE < 0.0 }
    BEGIN
      IF z.RE < -1.0 THEN wurzel:= SQRT( ein_halb * betrag - ein_halb * x )
      ELSE
        wurzel:= SQRT( ein_halb * ( betrag - x ) );
      zwischen:= SHORT( ( ein_halb * LONG( ABS( z.IM ) ) ) / wurzel );

      { SQRT:= 0.5 * ABS( z.IM ) * 1 / SQRT ( 0.5 * ABS( z ) - 0.5 * z.RE )
                 +- i * SQRT( 0.5 * ABS( z ) - 0.5 * z.RE )    
       }

      SQRT.RE:= zwischen;
      IF z.IM > 0.0 THEN SQRT.IM:= SHORT( wurzel )
      ELSE
        SQRT.IM:= -SHORT( wurzel )
    END
  END
END;




{---------------------------------------------------------------------------}
{    5.5 Exponentialfunktion                                                }
{---------------------------------------------------------------------------}
 
 
GLOBAL FUNCTION EXP( VAR z : COMPLEX ) : COMPLEX;

VAR LEXP : LONGREAL;

BEGIN
  LEXP:= L_EXP( z.RE );

  { EXP:= EXP( z.RE ) * COS( z.IM ) + i * EXP( z.RE ) * SIN( z.IM ) }

  EXP:= COMPL(  SHORT( LEXP * L_COS( z.IM ) ) ,
                 SHORT( LEXP * L_SIN( z.IM ) )   )
END;
 



{---------------------------------------------------------------------------}
{    5.6 Logarithmus                                                        }
{---------------------------------------------------------------------------}

 
GLOBAL FUNCTION LN ( z : COMPLEX ) : COMPLEX ;

CONST ueberlaufgrenze = 1E50;
      unterlaufgrenze = 1E-50;

VAR x, y, sqrx_plus_sqry : REAL;
    zaehler, nenner      : LONGREAL;
    akku                 : DOTPRECISION;

BEGIN
  IF ( ABS( z.RE ) >= ueberlaufgrenze ) OR ( ABS( z.IM ) >= ueberlaufgrenze )
  THEN
  BEGIN  { Ueberlauf vermeiden }
    x:= unterlaufgrenze * z.RE;
    y:= unterlaufgrenze * z.IM;
    sqrx_plus_sqry:= #*( x * x + y * y );

    { LN:= 0.5 * LN( SQR( x ) + SQR( y ) ) + 50 * LN( 10 )
             + i * ARG( z )                                  }

    LN:= COMPL( SHORT( LONG( 0.5 ) * L_LN( sqrx_plus_sqry )
                        + LONG( 50 ) * L_LN( 10 )            ), ARG( z ) )
  END
  ELSE 
    IF ( ABS( z.RE ) < unterlaufgrenze ) AND ( ABS( z.IM ) < unterlaufgrenze )
    THEN
    BEGIN  { Unterlauf vermeiden }
      x:= ueberlaufgrenze * z.RE;
      y:= ueberlaufgrenze * z.IM;
      sqrx_plus_sqry:= #*( x * x + y * y );
       
      { LN wie oben nur - ( 50 * LN( 10 ) ) statt + }
       
      LN:= COMPL( SHORT( ( LONG( 0.5 ) * L_LN( sqrx_plus_sqry ) )
                          - ( LONG( 50 ) * L_LN( 10 ) )            )
                   , ARG( z )                                       )
    END
    ELSE
    BEGIN
      akku:= #( z.RE * z.RE + z.IM * z.IM );
      sqrx_plus_sqry:= #*( akku );
      IF ( sqrx_plus_sqry >= 0.9999 ) AND ( sqrx_plus_sqry <= 1.0001 ) THEN
      BEGIN  { Sonderbehandlung, da sonst Argument von LN zu nahe bei 1 }
       
        { LN:= 0.5 * R( V ) + i * ARG( z ) mit
           V:= ( SQR( z.RE ) + SQR( z.IM ) - 1 )
                / ( SQR( z.RE ) + SQR( z.IM ) + 1 ) }
        akku:= #( akku - 1.0 );
        zaehler:= l_dotround( akku );
        akku:= #( akku + 2 );
        nenner:= l_dotround( akku );
        LN:= COMPL( SHORT( LONG( 0.5 ) * LN_APP( zaehler / nenner ) )
                     , ARG( z )                                       )
      END
      ELSE
      BEGIN
       
        { LN:= 0.5 * LN( SQR( x ) + SQR( y ) ) + i * ARG( z ) }
         
        zaehler:= l_dotround( akku );
        LN:= COMPL( SHORT( LONG( 0.5 ) * LN( zaehler ) ), ARG( z ) )
      END
    END
END;
 



{---------------------------------------------------------------------------}
{    5.7 Sinus                                                              }
{---------------------------------------------------------------------------}

 
GLOBAL FUNCTION SIN( VAR z : COMPLEX ) : COMPLEX;

BEGIN
  SIN:= COMPL(  SHORT( L_SIN( z.RE ) * L_COSH( z.IM ) ) ,
                 SHORT( L_COS( z.RE ) * L_SINH( z.IM ) )   )
END; 




{---------------------------------------------------------------------------}
{    5.8 Cosinus                                                            }
{---------------------------------------------------------------------------}
  
 
GLOBAL FUNCTION COS( VAR z : COMPLEX ) : COMPLEX;

BEGIN
  COS:= COMPL(  SHORT( L_COS( z.RE ) * L_COSH( z.IM ) ) ,
                -SHORT( L_SIN( z.RE ) * L_SINH( z.IM ) )   )
END; 



 
{---------------------------------------------------------------------------}
{    5.9 Arkustangens                                                       }
{---------------------------------------------------------------------------}

 
GLOBAL FUNCTION ARCTAN( z: COMPLEX ) : COMPLEX;

CONST pi = 3.141592653590;

VAR pseudo, realteil    : REAL;
    zwischen            : LONGREAL;
    zaehler, nenner     : LONGREAL;
    akku                : DOTPRECISION;
    
BEGIN
  akku:= #( z.RE * z.RE + z.IM * z.IM );   {:= SQR( x ) + SQR( y ) } 
  pseudo:= #*( akku - 1.0 );
  pseudo:= -pseudo;
  realteil:= ARCTAN2( 2 * z.RE, pseudo ); { ERZEUGT AUCH FEHLERABBRUCH}
  IF pseudo < 0.0 THEN
    IF z.RE > 0.0 THEN           { realteil HAT VORZEICHEN VON z.RE }
      realteil:= realteil + pi
    ELSE
      realteil:= realteil - pi;
  akku:= #( akku + 2 * z.IM + 1.0 );   {:= SQR( x ) + SQR( y ) + 2 * y + 1 } 
  zaehler:= l_dotround( akku );
  akku:= #( akku - 4 * z.IM );       {:= SQR( x ) + SQR( y ) - 2 * y + 1 }
  nenner:= l_dotround( akku );
  zwischen:= zaehler / nenner;

  ARCTAN.RE:= 0.5 * realteil;
  IF ( zwischen >= LONG( 0.9999 ) ) AND ( zwischen <= LONG( 1.0001 ) ) THEN

    { ARCTAN:= 0.5 * ARG( 1 - SQR( x ) - SQR( y ) + i * 2 * x )
                 + i * 0.25 * V * R( V )       
       mit V:= 2 * y / ( SQR( x )+ SQR( y ) + 1 )                }

  BEGIN
    akku:= #( akku + 2 * z.IM );    {:= SQR( x ) + SQR( y ) + 1 }
    nenner:= l_dotround( akku );
    ARCTAN.IM:= SHORT( LONG( 0.25 )
                        * LN_APP( ( LONG( 2 ) * LONG( z.IM ) ) / nenner ) )
  END
  ELSE
 
    { ARCTAN:= 0.5 * ARG( 1 - SQR( y ) - SQR( x ) + i * 2 * x )
                 + i * 0.25 * LN( ( SQR( x ) + SQR( y ) + 2 * y + 1 )
                                  / ( SQR( x ) + SQR( y ) - 2 * y + 1 ) ) }
    ARCTAN.IM:= SHORT( LONG( 0.25 ) * LN( zwischen ) )
END;




{---------------------------------------------------------------------------}
{    5.10 Zusaetzliche Standardfunktionen                                   }
{---------------------------------------------------------------------------}


{---------------------------------------------------------------------------}
{    5.10.1 EXP2                                                            }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION EXP2  ( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   EXP2:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.2 EXP10                                                           }
{---------------------------------------------------------------------------}



GLOBAL FUNCTION EXP10 ( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   EXP10:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.3 LOG2                                                            }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION LOG2  ( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   LOG2:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.4 LOG10                                                           }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION LOG10 ( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   LOG10:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.5 TAN                                                             }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION TAN   ( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   TAN:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.6 COT                                                             }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION COT   ( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   COT:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.7 ARCSIN                                                          }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARCSIN( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   ARCSIN:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.8 ARCCOS                                                          }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARCCOS( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   ARCCOS:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.9 ARCTAN2                                                         }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARCTAN2( VAR x,y : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   ARCTAN2:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.10 ARCCOT                                                         }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARCCOT( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   ARCCOT:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.11 SINH                                                           }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION SINH  ( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   SINH:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.12 COSH                                                           }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION COSH  ( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   COSH:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.13 TANH                                                           }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION TANH  ( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   TANH:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.14 COTH                                                           }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION COTH  ( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   COTH:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.15 ARSINH                                                         }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARSINH( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   ARSINH:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.16 ARCOSH                                                         }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARCOSH( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   ARCOSH:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.17 ARTANH                                                         }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARTANH( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   ARTANH:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.18 ARCOTH                                                         }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARCOTH( VAR x : COMPLEX ) : COMPLEX;
BEGIN
   _c_MATH_ERROR( 250 );  { Function not yet implemented }
   ARCOTH:= X;
END;


$on


{---------------------------------------------------------------------------}
{ 6. Ein- / Ausgabe                                                         }
{---------------------------------------------------------------------------}




GLOBAL PROCEDURE READ  ( VAR F : TEXT; VAR A : COMPLEX );
VAR zeichen : CHAR;

  PROCEDURE skipblanks;
  BEGIN
    WHILE F^ = ' ' DO READ( F, zeichen )
  END;

BEGIN   { READ }
  skipblanks;

  IF F^ <> '('  THEN
  BEGIN
     READ ( F, A.RE );
     A.IM:= 0.0;
  END ELSE
  BEGIN
     READ ( F,zeichen );                 { '(' ueberlesen } 
     READ( F, A.RE );
     skipblanks;
     IF F^ <> ',' THEN _c_MATH_ERROR (92);
     READ ( F,zeichen );                 { ',' ueberlesen } 
     READ( F, A.IM ); 
     skipblanks;
     IF F^ <> ')' THEN _c_MATH_ERROR (92);
     READ( F, zeichen );                 { ')' ueberlesen }
  END;
END;




GLOBAL PROCEDURE WRITE ( VAR F : TEXT; A : COMPLEX );

BEGIN
  WRITE( F, '( ', A.RE, ', ', A.IM, ' )' )
END;




END.  { of module C_ARI }
