MODULE awatypes;

USE GLOBAL awalangu;

USE GLOBAL i_ari,mv_ari,mvi_ari;

GLOBAL
CONST SMAX  = 15;                    { Stringlaenge fuer Variablen    }


GLOBAL
TYPE

   FORMEL   =  GLOBAL ^TFORMEL;             { Zeiger auf intern in Baum-   }
                                     { struktur dargestellte Funk-  }
                                     { tionsausdruecke              }
   FVECTOR  = GLOBAL DYNAMIC ARRAY [*] OF FORMEL;   { Vektor von solchen Zeigern }
   FMATRIX  = GLOBAL DYNAMIC ARRAY [*] OF FVECTOR;
 
   { Der Typ OPERATION dient 1. zur Unterscheidung der verschiedenen Ope-    }
   { rationen in den Knoten der internen Baumstruktur fuer Funktionsaus-     }
   { druecke ( PLUS,...,VARIABLE, siehe CASE in Record TFORMEL ), sowie 2.   }
   { zur Identifizierung von Eingabe-Einheiten beim Einlesen der Funktions-  }
   { ausdruecke ( siehe Paket EINGABE.PAK ).                                 }

   OPERATION =  GLOBAL
	       ( UVARIABLE,AVARIABLE, KONST,  UMINUS,
	         PLUS,   MINUS,    MAL,       DURCH,   QUAD,
		 WURZ,   HOCH,     EFKT,      LOGA,
		 SINUS,  COSIN,    TANG,      COTANG,
		 SINUSH, COSINH,   TANGH,     COTANGH,
		 ARCSI,  ARCCO,    ARCTG,     ARCCTG,
		 ARSIH,  ARCOH,    ARTGH,     ARCTGH,  SINCOS,
                 KLAUF,  KLZU,     GLEICH,    STRICHP, PRT,
                 ECKAUF, DOLLAR,   BLANK,     ZIFFER,  BUCHST, FEHLER );


   { Der Record TFORMEL dient zur Darstellung eines Knotens in der internen  }
   { Baumstruktur fuer Funktionsausdruecke. Bedeutung der Variablen darin :  }
   {                                                                         }
   { STATUS    : Die globale Variable FERTIG wird vor jeder Funktionsauswer- }
   {             tung um eins hochgezaehlt. Nach der Auswertung der zum vor- }
   {             liegenden Knoten gehoerenden Teilformel wird STATUS:= FERTIG}
   {             gesetzt,so dass eine erneute Auswertung nicht notwendig ist,}
   {             wenn dieselbe Teilformel noch weitere Male im Funktionsaus- }
   {             druck auftritt. Das Ergebnis braucht dann nur aus W aus-    }
   {             gelesen zu werden.  ( siehe Funktion EVAL)                  }
   { OPER      : Enthaelt jeweils vorliegendes Operationssymbol.             }
   { LI,RE     : Zeiger auf die beiden Operanden bei binaeren Operationen.   }
   {             SIN,COS ( und SINH,COSH ) werden jeweils als Knoten-Paare   }
   {             angelegt, da in den Rekursionsformeln fuer die Taylorkoeffi-}
   {             zienten beide Funktionen vorkommen. ( siehe Funktion FKNOTEN}
   {             im Paket FKNOTEN.PAK )                                      }
   { R         : Zeiger auf Operand bei unaeren Operationen.                 }
   { EXPO      : Exponent, wenn OPER=HOCH ( Exponentiation mit Konstanten ). }
   { NR        : Index der abhaengigen Variablen  ( 1 <= NR <= DIM ).        }

   TFORMEL  =  GLOBAL 
               RECORD
                  STATUS,I,J  : INTEGER;
                  CASE  OPER : OPERATION OF
                      PLUS,   MINUS,  MAL,   DURCH,
                      SINUS,  COSIN,  TANG,  COTANG,
		      SINUSH, COSINH, TANGH, COTANGH,
		      ARCSI,  ARCCO,  ARCTG, ARCCTG,
		      ARSIH,  ARCOH,  ARTGH, ARCTGH  : ( LI,RE  : FORMEL  );
                      UMINUS,QUAD,WURZ,HOCH,EFKT,LOGA:
                                                       ( R      : FORMEL;
                                                         EXPO   : INTERVAL );
                      KONST,UVARIABLE:                 ( WERT   : INTERVAL );
               END { RECORD TFORMEL };
 
   { Typ-Vereinbarungen fuer Paket EINGABE.PAK :                             }

   H_VARIABLEN = GLOBAL ^H_VAR;             { Zeiger fuer Liste von Eingabevariablen}

   H_VAR = GLOBAL
           RECORD                    { Record zum Aufbau einer Liste aller   }
             NAME     : STRING[SMAX];{ Eingabevariablen mit:                 }
             AUSDRUCK : FORMEL;      { NAME    : Name der Variablen          }
             NEXT     : H_VARIABLEN; { AUSDRUCK: Zeiger auf Formel, fuer die }
           END { RECORD H_VAR };     {           die Variable steht          }
                                     { NEXT    : Zeiger auf naechste Variable}



END.
